443. String Compression

问题描述:

Given an array of characters, compress it in-place.

The length after compression must always be smaller than or equal to the original array.

Every element of the array should be a character (not int) of length 1.

After you are done modifying the input array in-place, return the new length of the array.

Follow up:
Could you solve it using only O(1) extra space?

Example 1:

Input:
["a","a","b","b","c","c","c"]

Output:
Return 6, and the first 6 characters of the input array should be: ["a","2","b","2","c","3"]

Explanation:
"aa" is replaced by "a2". "bb" is replaced by "b2". "ccc" is replaced by "c3".

Example 2:

Input:
["a"]

Output:
Return 1, and the first 1 characters of the input array should be: ["a"]

Explanation:
Nothing is replaced.

Example 3:

Input:
["a","b","b","b","b","b","b","b","b","b","b","b","b"]

Output:
Return 4, and the first 4 characters of the input array should be: ["a","b","1","2"].

Explanation:
Since the character "a" does not repeat, it is not compressed. "bbbbbbbbbbbb" is replaced by "b12".
Notice each digit has it‘s own entry in the array.

Note:

  1. All characters have an ASCII value in [35, 126].
  2. 1 <= len(chars) <= 1000.

解题思路:

在现有位置上压缩,用cur来记录当前字符,count记录出现个数,若遍历到的字符:

  1. chars[i] == cur : count++;

  2.chars[i] != cur:将cur及其出现次数更新在chars中, 需要注意的是:当cur>1时,才把数字记入字符数组中

另有一点需要注意:

  推出循环时,仍有最后一个字符没有计入到数组中!所以需再加一遍。

代码:

class Solution {
public:
    int compress(vector<char>& chars) {
        int n = chars.size();
        if(n < 2)
            return n;
        char cur = chars[0];
        int count = 0;
        int pos = 0;
        for(int i = 0; i < n; i++){
            if(chars[i] == cur){
                count++;
            }else{
                chars[pos] = cur;
                pos++;
                if(count > 1){
                    string digit = to_string(count);
                    for(int j = 0; j < digit.size(); j++)
                        chars[pos++] = digit[j];
                }
                count = 1;
                cur = chars[i];
            }
        }
        chars[pos++] = cur;
        if(count > 1){
            string digit = to_string(count);
            for(int j = 0; j < digit.size(); j++)
                chars[pos++] = digit[j];
        }
        return pos;
    }
};

原文地址:https://www.cnblogs.com/yaoyudadudu/p/9139507.html

时间: 2024-10-01 06:44:03

443. String Compression的相关文章

443. String Compression - LeetCode

Question 443.?String Compression Solution 题目大意:把一个有序数组压缩, 思路:遍历数组 Java实现: public int compress(char[] chars) { if (chars.length == 0) return 0; StringBuilder sb = new StringBuilder(); char cur = chars[0]; int sum = 1; for (int i = 1; i <= chars.length

443. String Compression 字符串压缩

Given an array of characters, compress it in-place. The length after compression must always be smaller than or equal to the original array. Every element of the array should be a character (not int) of length 1. After you are done modifying the inpu

【leetcode】443. String Compression

题目如下: Given an array of characters, compress it in-place. The length after compression must always be smaller than or equal to the original array. Every element of the array should be a character (not int) of length 1. After you are done modifying th

[LC] 443. String Compression

Given an array of characters, compress it in-place. The length after compression must always be smaller than or equal to the original array. Every element of the array should be a character (not int) of length 1. After you are done modifying the inpu

443 String Compression 压缩字符串

给定一组字符,使用原地算法将其压缩.压缩后的长度必须始终小于或等于原数组长度.数组的每个元素应该是长度为1 的字符(不是 int 整数类型).在完成原地修改输入数组后,返回数组的新长度.进阶:你能否仅使用O(1) 空间解决问题?示例 1:输入:["a","a","b","b","c","c","c"]输出:返回6,输入数组的前6个字符应该是:["a"

Leetcode 443 String Compression

基础的字符串操作,用两个指针扫一遍就行. class Solution(object): def compress(self,chars): """ :type chars: List[str] :rtype: int """ if not chars: return 0 if len(chars) == 1: return 1 left, right, num = 0, 1, 1 while right <= len(chars): if

LeetCode_443. String Compression

443. String Compression Easy Given an array of characters, compress it in-place. The length after compression must always be smaller than or equal to the original array. Every element of the array should be a character (not int) of length 1. After yo

codeforces 825F F. String Compression dp+kmp找字符串的最小循环节

/** 题目:F. String Compression 链接:http://codeforces.com/problemset/problem/825/F 题意:压缩字符串后求最小长度. 思路: dp[i]表示前i个字符需要的最小次数. dp[i] = min(dp[j]+w(j+1,i)); (0<=j<i); [j+1,i]如果存在循环节(自身不算),那么取最小的循环节x.w = digit((i-j)/x)+x; 否则w = i-j+1; 求一个区间最小循环节: 证明:http://w

Educational Codeforces Round 25 F. String Compression(kmp+dp)

题目链接:Educational Codeforces Round 25 F. String Compression 题意: 给你一个字符串,让你压缩,问压缩后最小的长度是多少. 压缩的形式为x(...)x(...)  x表示(...)这个出现的次数. 题解: 考虑dp[i]表示前i个字符压缩后的最小长度. 转移方程解释看代码,这里要用到kmp来找最小的循环节. 当然还有一种找循环节的方式就是预处理lcp,然后通过枚举循环节的方式. 这里我用的kmp找的循环节.复杂度严格n2. 1 #inclu